﻿Module Module1
  Private ReadOnly Commands As List(Of String) = {"SET", "GET", "DEL", "PSET", "PGET", "DBDEL", "DBCREATE", "DBGET", "DBLIST", "LIST", "PLIST", "PDEL", "CON", "LCON", "CLOSE", "CLS", "STATE", "HELP"}.ToList

  Const cSET As String = "SET"
  Const cGET As String = "GET"
  Const cDEL As String = "DEL"
  Const cPSET As String = "PSET"
  Const cPGET As String = "PGET"
  Const cPDEL As String = "PDEL"
  Const cDBDEL As String = "DBDEL"
  Const cDBGET As String = "DBGET"
  Const cCON As String = "CON"
  Const cLCON As String = "LCON"
  Const cCLOSE As String = "CLOSE"
  Const cCLS As String = "CLS"
  Const cSTATE As String = "STATE"
  Const cDBCREATE As String = "DBCREATE"
  Const cDBLIST As String = "DBLIST"
  Const cLIST As String = "LIST"
  Const cPLIST As String = "PLIST"
  Const cHELP As String = "HELP"

  Private sql As New SNCS.Client
  Private _stay As Boolean = True
  Private _IgnoreStayOnExit As Boolean = False

  Function Main() As Integer
    Dim args() As String = Environment.GetCommandLineArgs()
    'Console.TreatControlCAsInput = True
    Dim _command As String
    If args.Count = 2 Then
      _command = args(1).ToUpper
    ElseIf args.Count > 2 Then
      _command = args(1).ToUpper
      If "true".StartsWith(args(2).ToLower.Trim) Then
        _IgnoreStayOnExit = True
      End If
    Else
      _command = String.Empty
    End If
    Do While _stay
      _stay = False
      If _command = "4as86d49egf4w65sdf13sd2f1s32f1sd" Then 'If command <> "" Then
        Try
          Return Run(args)
          End
        Catch ex As Exception
          Console.WriteLine(ex.Message)
          Console.WriteLine(ex.StackTrace)
          End
        End Try
      ElseIf IO.File.Exists(_command) Then
        Using sr As New IO.StreamReader(_command, System.Text.Encoding.Default, True)
          Dim line As String = String.Empty
          Do While Not sr.EndOfStream
            line = sr.ReadLine.Trim
            If "stay".StartsWith(line.ToLower) Then
              _stay = True
              _command = "0"
            ElseIf "if".StartsWith(line.ToLower) AndAlso line.ToLower.Contains("then") Then
              Dim tmpcommand As String = line.Substring(2).Trim
              Dim cond As String = System.Text.RegularExpressions.Regex.Split(tmpcommand, "then", Text.RegularExpressions.RegexOptions.IgnoreCase)(0)



            ElseIf Not String.IsNullOrWhiteSpace(line) AndAlso Not line.StartsWith("#") Then
              Console.WriteLine("")
              Console.WriteLine(line.Trim)
              If "exit".StartsWith(line.ToLower) Then
                If _IgnoreStayOnExit Then _stay = False
                Exit Do
              End If
              If Run(line.Split("#"c)(0).Split(" "c)) <> 0 Then '.Split(" "c)
                Exit Do
              End If
            End If
          Loop
        End Using
      Else
        Dim tmp As String = String.Empty
        Dim running As Boolean = True
        Dim comlist As New List(Of String)
        Dim combuilder As New Text.StringBuilder()
        Do While running
          Console.Write("Command: ") : tmp = Console.ReadLine
          comlist.Clear()
          Try
            If Not String.IsNullOrWhiteSpace(tmp.ToLower.Trim) Then
              If Not "exit".StartsWith(tmp.ToLower) Then
                If tmp.ToUpper.Contains("AND") Then
                  For Each c As String In System.Text.RegularExpressions.Regex.Split(tmp.Trim, "AND", Text.RegularExpressions.RegexOptions.IgnoreCase)
                    Console.WriteLine("")
                    Console.WriteLine(c.Trim)
                    If Not String.IsNullOrWhiteSpace(c.Trim.ToLower) AndAlso "exit".StartsWith(c.Trim.ToLower) Then
                      running = False
                      Exit For
                    End If
                    If Run(c.Trim.Split(" "c)) <> 0 Then
                      Exit For
                    End If
                  Next
                ElseIf tmp.Contains("&&") Then
                  For Each c As String In System.Text.RegularExpressions.Regex.Split(tmp.Trim, System.Text.RegularExpressions.Regex.Escape("&&"), Text.RegularExpressions.RegexOptions.IgnoreCase)
                    Console.WriteLine("")
                    Console.WriteLine(c.Trim)
                    If Not String.IsNullOrWhiteSpace(c.Trim.ToLower) AndAlso "exit".StartsWith(c.Trim.ToLower) Then
                      running = False
                      Exit For
                    End If
                    If Run(c.Trim.Split(" "c)) <> 0 Then '.Split(" "c)
                      Exit For
                    End If
                  Next
                Else
                  Run(tmp.Trim.Split(" "c))
                End If
              Else
                running = False
              End If
            Else
              Console.WriteLine("")
            End If
          Catch ex As Exception
            Console.WriteLine(ex.Message)
            Console.WriteLine(ex.StackTrace)
          End Try
        Loop
      End If
    Loop
    Return 0
  End Function

  Private Sub ShowHelp(ByVal Command As String)
    Select Case Command

      Case cSET
        Console.WriteLine("Syntax: {0}SET [Name] [Value]{0}", Chr(34))
        Console.WriteLine("")
      Case cGET
        Console.WriteLine("Syntax: {0}GET [Name]{0}", Chr(34))
        Console.WriteLine("")
      Case cDEL
        Console.WriteLine("Syntax: {0}DEL [Name]{0}", Chr(34))
        Console.WriteLine("")
      Case cPSET
        Console.WriteLine("Syntax: {0}PSET [Identifier] [Name] [Value]{0}", Chr(34))
        Console.WriteLine("")
      Case cPGET
        Console.WriteLine("Syntax: {0}PGET [Identifier] [Name]{0}", Chr(34))
        Console.WriteLine("")
      Case cPDEL
        Console.WriteLine("Syntax: {0}PDEL [Identifier] [Name]{0}", Chr(34))
        Console.WriteLine("")
      Case cCON
        Console.WriteLine("Remote Service:")
        Console.WriteLine("Syntax: {0}CON [ServerName or IP]{0}", Chr(34))
        Console.WriteLine("")
        Console.WriteLine("Remote Service (Different Port):")
        Console.WriteLine("Syntax: {0}CON [ServerName or IP] [Port]{0}", Chr(34))
        Console.WriteLine("")
      Case cLCON
        Console.WriteLine("Local Service:")
        Console.WriteLine("Syntax: {0}CON{0}", Chr(34))
        Console.WriteLine("")
        Console.WriteLine("Local Service (Different Port):")
        Console.WriteLine("Syntax: {0}CON [Port]{0}", Chr(34))
        Console.WriteLine("")
      Case cDBGET
        Console.WriteLine("Syntax: {0}DBGET [Identifier]{0}", Chr(34))
        Console.WriteLine("")
      Case cDBCREATE
        Console.WriteLine("Syntax: {0}DBCREATE [Identifier]{0}", Chr(34))
        Console.WriteLine("")
      Case cDBDEL
        Console.WriteLine("Syntax: {0}DBDEL [Identifier]{0}", Chr(34))
        Console.WriteLine("")
      Case cDBLIST
        Console.WriteLine("Syntax: {0}DBLIST Optional:[Identifier]{0}", Chr(34))
        Console.WriteLine("")
      Case cLIST
        Console.WriteLine("Syntax: {0}LIST Optional:[Name]{0}", Chr(34))
        Console.WriteLine("")
      Case cPLIST
        Console.WriteLine("Syntax: {0}PLIST [Identifier] Optional:[Name]{0}", Chr(34))
        Console.WriteLine("")
      Case Else
        Console.WriteLine("Syntax: {0}Command {1}Argumentlist{2}{0}", Chr(34), "{", "}")
        Console.WriteLine("")
        Console.WriteLine("Commands:")
        Console.WriteLine(cCON)
        Console.WriteLine("Connects to a data service")
        Console.WriteLine("")
        Console.WriteLine(cLCON)
        Console.WriteLine("Connects to a local data service")
        Console.WriteLine("")
        Console.WriteLine(cCLOSE)
        Console.WriteLine("Closes the connection to a data service")
        Console.WriteLine("")

        'Console.WriteLine(cLIST)
        'Console.WriteLine("Lists all ")
        'Console.WriteLine("")
        'Console.WriteLine(cCLOSE)
        'Console.WriteLine("Closes the connection to a data service")
        'Console.WriteLine("")
        'Console.WriteLine(cCLOSE)
        'Console.WriteLine("Closes the connection to a data service")
        'Console.WriteLine("")


        Console.WriteLine(cSET)
        Console.WriteLine("Sets a general value")
        Console.WriteLine("")
        Console.WriteLine(cGET)
        Console.WriteLine("Gets a general value")
        Console.WriteLine("")
        Console.WriteLine(cDEL)
        Console.WriteLine("Deletes a general value")
        Console.WriteLine("")
        Console.WriteLine(cDBGET)
        Console.WriteLine("Gets a DB with the specified identifier")
        Console.WriteLine("")
        Console.WriteLine(cDBCREATE)
        Console.WriteLine("Creates a DB with the specified identifier")
        Console.WriteLine("")
        Console.WriteLine(cDBDEL)
        Console.WriteLine("Deletes all private values with the specified identifier")
        Console.WriteLine("")
        Console.WriteLine(cPSET)
        Console.WriteLine("Sets a private value")
        Console.WriteLine("")
        Console.WriteLine(cPGET)
        Console.WriteLine("Gets a private value")
        Console.WriteLine("")
        Console.WriteLine(cPDEL)
        Console.WriteLine("Deletes a private value")
        Console.WriteLine("")
        Console.WriteLine(cSTATE)
        Console.WriteLine("Shows the connection state")
        Console.WriteLine("")
        Console.WriteLine(cCLS)
        Console.WriteLine("Clears the Screen")
        Console.WriteLine("")
        Console.WriteLine("For detailed help, use the Command: {0}[CommandName]{0}", Chr(34))
        Console.WriteLine("")
        Console.WriteLine("")
    End Select
  End Sub

  Private CommandBuilder As New Text.StringBuilder
  Private _ArgList As New List(Of String)
  Private Function Run(ByVal args() As String) As Integer
    Dim _command As String = args(0).ToUpper
    Dim retval As Integer = 0
    Dim rerun As Boolean = True
    Dim showhelpnow As Boolean = False
    If Not Commands.Contains(_command) Then
      Do While rerun
        Dim shelp As Boolean = True
        If Not String.IsNullOrWhiteSpace(_command.Trim) Then
          If Commands.FirstOrDefault(Function(s As String) As Boolean
                                       Return s.StartsWith(_command)
                                     End Function) <> "" Then
            shelp = False
            For Each s As String In Commands
              If s.StartsWith(_command) Then
                _command = s
                Exit For
              End If
            Next
          End If
        End If
        If _command = cHELP AndAlso args.Count > 1 Then
          rerun = True
          showhelpnow = True
          _command = args(1).ToUpper
        ElseIf _command = cHELP Then
          ShowHelp(_command)
          Return 1
          Exit Function
        Else
          rerun = False
          If shelp OrElse showhelpnow Then
            ShowHelp(_command)
            Return 1
            Exit Function
          End If
        End If
      Loop
    End If

    CommandBuilder.Clear()
    _ArgList.Clear()
    If _command = cSET OrElse _command = cPGET OrElse _command = cPDEL Then
      If args.Count < 3 Then
        Console.WriteLine("Wrong Parametercount!")
        Console.WriteLine("")
        ShowHelp(_command)
        Return 1
      End If
      If args.Count > 3 Then
        For i As Integer = 2 To args.GetUpperBound(0) Step 1
          CommandBuilder.Append(args(i))
          CommandBuilder.Append(" ")
        Next

        For i As Integer = 0 To 1
          _ArgList.Add(args(i))
        Next
        _ArgList.Add(CommandBuilder.ToString.Trim)
        args = _ArgList.ToArray
      End If
    ElseIf _command = cGET Then
      If args.Count < 2 Then
        Console.WriteLine("Wrong Parametercount!")
        Console.WriteLine("")
        ShowHelp(_command)
        Return 1
      End If
      If args.Count > 2 Then
        For i As Integer = 1 To args.GetUpperBound(0) Step 1
          CommandBuilder.Append(args(i))
          CommandBuilder.Append(" ")
        Next

        For i As Integer = 0 To 0
          _ArgList.Add(args(i))
        Next
        _ArgList.Add(CommandBuilder.ToString.Trim)
        args = _ArgList.ToArray
      End If
    ElseIf _command = cPSET Then
      If args.Count < 4 Then
        Console.WriteLine("Wrong Parametercount!")
        Console.WriteLine("")
        ShowHelp(_command)
        Return 1
      End If
      If args.Count > 4 Then
        For i As Integer = 3 To args.GetUpperBound(0) Step 1
          CommandBuilder.Append(args(i))
          CommandBuilder.Append(" ")
        Next

        For i As Integer = 0 To 2
          _ArgList.Add(args(i))
        Next
        _ArgList.Add(CommandBuilder.ToString.Trim)
        args = _ArgList.ToArray
      End If
    ElseIf _command = cCON Then
      If args.Count < 2 AndAlso args.Count < 3 Then
        Console.WriteLine("Wrong Parametercount!")
        Console.WriteLine("")
        ShowHelp(_command)
        Return 1
      End If
    ElseIf _command = cLCON Then
      If args.Count < 2 AndAlso args.Count < 1 Then
        Console.WriteLine("Wrong Parametercount!")
        Console.WriteLine("")
        ShowHelp(_command)
        Return 1
      End If
    ElseIf _command = cCLOSE OrElse _command = cCLS OrElse _command = cSTATE Then
      If args.Count < 1 Then
        Console.WriteLine("Wrong Parametercount!")
        Console.WriteLine("")
        ShowHelp(_command)
        Return 1
      End If
    ElseIf _command = cDBDEL OrElse _command = cDBGET OrElse _command = cDBCREATE Then
      If args.Count < 2 Then
        Console.WriteLine("Wrong Parametercount!")
        Console.WriteLine("")
        ShowHelp(_command)
        Return 1
      End If
    ElseIf _command = cLIST OrElse _command = cDBLIST Then
      If args.Count < 1 Then
        Console.WriteLine("Wrong Parametercount!")
        Console.WriteLine("")
        ShowHelp(_command)
        Return 1
      End If
    ElseIf _command = cPLIST Then
      If args.Count < 2 Then
        Console.WriteLine("Wrong Parametercount!")
        Console.WriteLine("")
        ShowHelp(_command)
        Return 1
      End If
    Else
      ShowHelp(cHELP)
      Return 1
    End If
    Dim tmp As String = String.Empty
    Select Case _command
      Case cCON
        If args.Count = 2 Then
          If sql.Connect(args(1)) Then
            retval = 2
          Else
            retval = 3
          End If
        Else
          If sql.Connect(args(1), Integer.Parse(args(2))) Then
            retval = 2
          Else
            retval = 3
          End If
        End If
      Case cLCON
        If args.Count = 1 Then
          If sql.Connect() Then
            retval = 2
          Else
            retval = 3
          End If
        Else
          If sql.Connect("localhost", Integer.Parse(args(2))) Then
            retval = 2
          Else
            retval = 3
          End If
        End If
      Case cCLOSE
        sql.Close()
        retval = 5
      Case cSET
        If sql.SetValue(args(1), args(2)) Then
          retval = 0
        Else
          retval = 1
        End If
      Case cGET
        tmp = sql.GetValue(args(1))
        If String.IsNullOrWhiteSpace(tmp) Then
          retval = 1
        Else
          Console.WriteLine("Result: {0}", tmp)
          retval = 0
        End If
      Case cDEL
        If sql.DelValue(args(1)) Then
          retval = 0
        Else
          retval = 1
        End If
      Case cPSET
        If sql.SetPrivateValue(sql.GetDB(args(1), False), args(2), args(3)) Then
          retval = 0
        Else
          retval = 1
        End If
      Case cPGET
        tmp = sql.GetPrivateValue(sql.GetDB(args(1), False), args(2))
        If String.IsNullOrWhiteSpace(tmp) Then
          retval = 1
        Else
          Console.WriteLine("Result: {0}", tmp)
          retval = 0
        End If
      Case cPDEL
        If sql.DelPrivateValue(sql.GetDB(args(1)), args(2)) Then
          retval = 0
        Else
          retval = 1
        End If
      Case cDBDEL
        If sql.DeleteDB(args(1)) Then
          retval = 0
        Else
          retval = 1
        End If
      Case cDBGET
        tmp = sql.GetDB(args(1), False)
        If Not String.IsNullOrWhiteSpace(tmp) Then
          retval = 6
        Else
          retval = 1
        End If
      Case cDBCREATE
        tmp = sql.GetDB(args(1))
        If Not String.IsNullOrWhiteSpace(tmp) Then
          retval = 4
        Else
          retval = 1
        End If
      Case cCLS
        Console.Clear()
        retval = -1
      Case cSTATE
        Console.WriteLine("Connected with {0}:{1}", sql.ConnectedServer, sql.ConnectedServerPort.ToString)
        Console.WriteLine("")
        retval = -1
      Case cLIST
        Console.WriteLine("")
        If args.Count < 2 Then
          For Each kv As KeyValuePair(Of String, String) In sql.ListValues
            Console.WriteLine("{0} = {1}", kv.Key, kv.Value)
          Next
        Else
          For Each kv As KeyValuePair(Of String, String) In sql.ListValues(args(1))
            Console.WriteLine("{0} = {1}", kv.Key, kv.Value)
          Next
        End If
        Console.WriteLine("")
        retval = -1
      Case cPLIST
        Console.WriteLine("")
        If args.Count < 3 Then
          For Each kv As KeyValuePair(Of String, String) In sql.ListPrivateValues(sql.GetDB(args(1), False))
            Console.WriteLine("{0} = {1}", kv.Key, kv.Value)
          Next
        Else
          For Each kv As KeyValuePair(Of String, String) In sql.ListPrivateValues(sql.GetDB(args(1), False), args(2))
            Console.WriteLine("{0} = {1}", kv.Key, kv.Value)
          Next
        End If
        Console.WriteLine("")
        retval = -1
      Case cDBLIST
        Console.WriteLine("")
        If args.Count < 2 Then
          For Each s As String In sql.ListDBs
            Console.WriteLine(s)
          Next
        Else
          For Each s As String In sql.ListDBs(args(1))
            Console.WriteLine(s)
          Next
        End If
        Console.WriteLine("")
        retval = -1
    End Select
    Select Case retval
      Case 0
        Console.WriteLine("Query successful!")
        Console.WriteLine("")
      Case -1
        retval = 0
      Case 2
        Console.WriteLine("Connection established!")
        Console.WriteLine("")
        retval = 0
      Case 3
        Console.WriteLine("Connection error!")
        Console.WriteLine("")
      Case 4
        Console.WriteLine("DB created | Query successful!")
        Console.WriteLine("")
        Console.WriteLine("ID: {0}", tmp)
        Console.WriteLine("")
        retval = 0
      Case 5
        Console.WriteLine("Connection closed!")
        Console.WriteLine("")
        retval = 0
      Case 6
        Console.WriteLine("DB found | Query successful!")
        Console.WriteLine("")
        Console.WriteLine("ID: {0}", tmp)
        Console.WriteLine("")
      Case Else
        Console.WriteLine("Query failed!")
        Console.WriteLine("")
    End Select
    Return retval

  End Function
End Module
