﻿Namespace RemoteableObject

  ''' <summary>
  ''' Das IObserver Interface, definiert die Signatur der Methode, die der Server ausführt.
  ''' </summary>
  ''' <remarks></remarks>
  <System.Runtime.InteropServices.ComVisible(False)>
  Public Interface IObserver
    Function SetValue(ByVal Name As String, ByVal Value As String) As Boolean
    Function GetValue(ByVal Name As String) As String
    Function DelValue(ByVal Name As String) As Boolean
    Function GetDB(ByVal Name As String, Optional ByVal CreateIfNotExist As Boolean = True) As String
    Function DeleteDB(ByVal Name As String) As Boolean
    Function ListDBs(Optional ByVal Identifier As String = "") As List(Of String)
    Function ListValues(Optional ByVal Name As String = "") As Dictionary(Of String, String)
    Function ListPrivateValues(ByVal Identifier As Guid, Optional ByVal Name As String = "") As Dictionary(Of String, String)
    Function SetPrivateValue(ByVal Identifier As Guid, ByVal Name As String, ByVal Value As String) As Boolean
    Function GetPrivateValue(ByVal Identifier As Guid, ByVal Name As String) As String
    Function DelPrivateValue(ByVal Identifier As Guid, ByVal Name As String) As Boolean
    Property Result As Boolean
  End Interface
End Namespace